"""
Module for checking artefact tags against compliance standards.

This module provides the `CheckArtefactTag` class, which is used to validate
the version tags of artefacts to ensure they comply with the Semantic
Versioning (semver) standards.

Classes:
    CheckArtefactTag: A class that performs validation on artefact version
        tags.
"""

import re

from ska_cicd_artefact_validations.core.artefact import Artefact, ArtefactType
from ska_cicd_artefact_validations.core.check import Check
from ska_cicd_artefact_validations.core.logging import logging
from ska_cicd_artefact_validations.core.message_generator import MessageType


class CheckArtefactTag(Check):
    """
    A class that performs validation on artefact version tags.

    This class checks the version tags of artefacts to ensure they follow
    Semantic Versioning (semver) standards. It logs errors and provides
    mitigation strategies if the tag is non-compliant.

    Attributes:
        feature_toggle: The feature toggle associated with this check.
    """

    feature_toggle = "check-component-tag"

    def __init__(self):
        pass

    async def check(self, artefact: Artefact) -> bool:
        """
        Checks if the artefact version tag complies with semver standards.

        This method uses a regex pattern to validate the version tag, ensuring
        it adheres to Semantic Versioning (semver) conventions.

        :param artefact: The artefact whose version tag is to be validated.
        :return: True if the artefact version tag is compliant, otherwise
            False.
        """
        artefact_tag = artefact.tag

        # https://semver.org/#is-there-a-suggested-regular-expression-regex-to-check-a-semver-string # pylint: disable=line-too-long # noqa: E501
        semver_regex = r"""^
            (?P<major>0|[1-9]\d*)\.
            (?P<minor>0|[1-9]\d*)\.
            (?P<patch>0|[1-9]\d*)(?:-
            (?P<prerelease>(?:0|[1-9]\d*|\d*[a-zA-Z-][0-9a-zA-Z-]*)(?:\.
            (?:0|[1-9]\d*|\d*[a-zA-Z-][0-9a-zA-Z-]*))*))?(?:\+
            (?P<buildmetadata>[0-9a-zA-Z-]+(?:\.[0-9a-zA-Z-]+)*))?
            $"""

        # https://packaging.python.org/en/latest/specifications/version-specifiers/#version-specifiers-regex # pylint: disable=line-too-long # noqa: E501
        pep440_regex = r"""^
            ([1-9][0-9]*!)?
            (0|[1-9][0-9]*)
            (\.(0|[1-9][0-9]*))*
            ((a|b|rc)(0|[1-9][0-9]*))?
            (\.post(0|[1-9][0-9]*))?
            (\.dev(0|[1-9][0-9]*))?
            $"""

        if artefact.type == ArtefactType.PYPI:
            key_match = re.search(pep440_regex, artefact_tag, re.VERBOSE)
        else:
            key_match = re.search(semver_regex, artefact_tag, re.VERBOSE)

        if not key_match:
            logging.error("Artefact Tag is invalid! - %s", artefact_tag)
            return False

        return True

    async def type(self) -> MessageType:
        """
        Returns the type of message generated by this check.

        :return: MessageType.FAILURE indicating a failed compliance check.
        """
        return MessageType.FAILURE

    async def description(self) -> str:
        """
        Provides a description of the artefact version tag compliance check.

        :return: A string describing the nature of the check failure.
        """
        return "Non-compliant Artefact Version Tag"

    async def mitigation_strategy(self) -> str:
        """
        Provides a mitigation strategy if the artefact version tag is
        non-compliant.

        This method guides the user on how to correct the artefact
        version tag according to the defined standards.

        :return: A string with the mitigation strategy and a link to the
            relevant guidelines.
        """
        return (
            "Artefact version is invalid! Please refer to "
            "[the developer portal](https://developer.skatelescope.org/en/latest/tools/software-package-release-procedure.html#versioning) "  # pylint: disable=line-too-long # noqa: E501
            "to correct this issue."
        )
